import{s as Ie,f as fe,n as Se,o as Ge}from"../chunks/scheduler.37c15a92.js";import{S as Ae,i as Oe,g as a,s as r,r as le,A as Ue,h as o,f as i,c as s,j as Ee,u as ue,x as l,k as h,y as We,a as n,v as he,d as me,t as ce,w as pe}from"../chunks/index.7cb9c9b8.js";import{H as de,E as Fe}from"../chunks/EditOnGithub.858acfec.js";function Be(ge){let u,E,z,I,m,S,c,we="This is an (optional) introduction to Curiosity. If you want to learn more, you can read two additional articles where we dive into the mathematical details:",G,p,ve='<li><a href="https://medium.com/data-from-the-trenches/curiosity-driven-learning-through-next-state-prediction-f7f4e2f592fa" rel="nofollow">Curiosity-Driven Learning through Next State Prediction</a></li> <li><a href="https://medium.com/data-from-the-trenches/curiosity-driven-learning-through-random-network-distillation-488ffd8e5938" rel="nofollow">Random Network Distillation: a new take on Curiosity-Driven Learning</a></li>',A,f,O,d,ye="To understand what Curiosity is, we first need to understand the two major problems with RL:",U,g,Te="First, the <em>sparse rewards problem:</em> that is, <strong>most rewards do not contain information, and hence are set to zero</strong>.",W,w,xe="Remember that RL is based on the <em>reward hypothesis</em>, which is the idea that each goal can be described as the maximization of the rewards. Therefore, rewards act as feedback for RL agents; <strong>if they don’t receive any, their knowledge of which action is appropriate (or not) cannot change</strong>.",F,v,Ce='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/curiosity1.png" alt="Curiosity"/> <figcaption>Source: Thanks to the reward, our agent knows that this action at that state was good</figcaption>',B,y,be=`For instance, in <a href="https://vizdoom.cs.put.edu.pl/" rel="nofollow">Vizdoom</a>, a set of environments based on the game Doom “DoomMyWayHome,” your agent is only rewarded <strong>if it finds the vest</strong>.
However, the vest is far away from your starting point, so most of your rewards will be zero. Therefore, if our agent does not receive useful feedback (dense rewards), it will take much longer to learn an optimal policy, and <strong>it can spend time turning around without finding the goal</strong>.`,N,T,_e,V,x,Le="The second big problem is that <strong>the extrinsic reward function is handmade; in each environment, a human has to implement a reward function</strong>. But how we can scale that in big and complex environments?",J,C,K,b,Me="A solution to these problems is <strong>to develop a reward function intrinsic to the agent, i.e., generated by the agent itself</strong>. The agent will act as a self-learner since it will be the student and its own feedback master.",Q,_,$e="<strong>This intrinsic reward mechanism is known as Curiosity</strong> because this reward pushes the agent to explore states that are novel/unfamiliar. To achieve that, our agent will receive a high reward when exploring new trajectories.",X,L,He="This reward is inspired by how humans act. <strong>We naturally have an intrinsic desire to explore environments and discover new things</strong>.",Y,M,Pe="There are different ways to calculate this intrinsic reward. The classical approach (Curiosity through next-state prediction) is to calculate Curiosity <strong>as the error of our agent in predicting the next state, given the current state and action taken</strong>.",Z,$,ke,ee,H,Re="Because the idea of Curiosity is to <strong>encourage our agent to perform actions that reduce the uncertainty in the agent’s ability to predict the consequences of its actions</strong> (uncertainty will be higher in areas where the agent has spent less time or in areas with complex dynamics).",te,P,je="If the agent spends a lot of time on these states, it will be good at predicting the next state (low Curiosity). On the other hand, if it’s in a new, unexplored state, it will be hard to predict the following state (high Curiosity).",ie,k,qe,ne,R,ze="Using Curiosity will push our agent to favor transitions with high prediction error (which will be higher in areas where the agent has spent less time, or in areas with complex dynamics) and <strong>consequently better explore our environment</strong>.",re,j,De='There’s also <strong>other curiosity calculation methods</strong>. ML-Agents uses a more advanced one called Curiosity through random network distillation. This is out of the scope of the tutorial but if you’re interested <a href="https://medium.com/data-from-the-trenches/curiosity-driven-learning-through-random-network-distillation-488ffd8e5938" rel="nofollow">I wrote an article explaining it in detail</a>.',se,q,ae,D,oe;return m=new de({props:{title:"(Optional) What is Curiosity in Deep Reinforcement Learning?",local:"optional-what-is-curiosity-in-deep-reinforcement-learning",headingTag:"h1"}}),f=new de({props:{title:"Two Major Problems in Modern RL",local:"two-major-problems-in-modern-rl",headingTag:"h2"}}),C=new de({props:{title:"So what is Curiosity?",local:"so-what-is-curiosity",headingTag:"h2"}}),q=new Fe({props:{source:"https://github.com/huggingface/deep-rl-class/blob/main/units/en/unit5/curiosity.mdx"}}),{c(){u=a("meta"),E=r(),z=a("p"),I=r(),le(m.$$.fragment),S=r(),c=a("p"),c.textContent=we,G=r(),p=a("ul"),p.innerHTML=ve,A=r(),le(f.$$.fragment),O=r(),d=a("p"),d.textContent=ye,U=r(),g=a("p"),g.innerHTML=Te,W=r(),w=a("p"),w.innerHTML=xe,F=r(),v=a("figure"),v.innerHTML=Ce,B=r(),y=a("p"),y.innerHTML=be,N=r(),T=a("img"),V=r(),x=a("p"),x.innerHTML=Le,J=r(),le(C.$$.fragment),K=r(),b=a("p"),b.innerHTML=Me,Q=r(),_=a("p"),_.innerHTML=$e,X=r(),L=a("p"),L.innerHTML=He,Y=r(),M=a("p"),M.innerHTML=Pe,Z=r(),$=a("img"),ee=r(),H=a("p"),H.innerHTML=Re,te=r(),P=a("p"),P.textContent=je,ie=r(),k=a("img"),ne=r(),R=a("p"),R.innerHTML=ze,re=r(),j=a("p"),j.innerHTML=De,se=r(),le(q.$$.fragment),ae=r(),D=a("p"),this.h()},l(e){const t=Ue("svelte-u9bgzb",document.head);u=o(t,"META",{name:!0,content:!0}),t.forEach(i),E=s(e),z=o(e,"P",{}),Ee(z).forEach(i),I=s(e),ue(m.$$.fragment,e),S=s(e),c=o(e,"P",{"data-svelte-h":!0}),l(c)!=="svelte-y7mcj"&&(c.textContent=we),G=s(e),p=o(e,"UL",{"data-svelte-h":!0}),l(p)!=="svelte-yq8zbl"&&(p.innerHTML=ve),A=s(e),ue(f.$$.fragment,e),O=s(e),d=o(e,"P",{"data-svelte-h":!0}),l(d)!=="svelte-15gibhd"&&(d.textContent=ye),U=s(e),g=o(e,"P",{"data-svelte-h":!0}),l(g)!=="svelte-1mrh6o3"&&(g.innerHTML=Te),W=s(e),w=o(e,"P",{"data-svelte-h":!0}),l(w)!=="svelte-iokskl"&&(w.innerHTML=xe),F=s(e),v=o(e,"FIGURE",{"data-svelte-h":!0}),l(v)!=="svelte-ebwuxg"&&(v.innerHTML=Ce),B=s(e),y=o(e,"P",{"data-svelte-h":!0}),l(y)!=="svelte-1154q0z"&&(y.innerHTML=be),N=s(e),T=o(e,"IMG",{src:!0,alt:!0}),V=s(e),x=o(e,"P",{"data-svelte-h":!0}),l(x)!=="svelte-1b7l79u"&&(x.innerHTML=Le),J=s(e),ue(C.$$.fragment,e),K=s(e),b=o(e,"P",{"data-svelte-h":!0}),l(b)!=="svelte-1ph3u47"&&(b.innerHTML=Me),Q=s(e),_=o(e,"P",{"data-svelte-h":!0}),l(_)!=="svelte-sk84ln"&&(_.innerHTML=$e),X=s(e),L=o(e,"P",{"data-svelte-h":!0}),l(L)!=="svelte-1ndmq20"&&(L.innerHTML=He),Y=s(e),M=o(e,"P",{"data-svelte-h":!0}),l(M)!=="svelte-14gr2jc"&&(M.innerHTML=Pe),Z=s(e),$=o(e,"IMG",{src:!0,alt:!0}),ee=s(e),H=o(e,"P",{"data-svelte-h":!0}),l(H)!=="svelte-1i7mr6w"&&(H.innerHTML=Re),te=s(e),P=o(e,"P",{"data-svelte-h":!0}),l(P)!=="svelte-sc9wuq"&&(P.textContent=je),ie=s(e),k=o(e,"IMG",{src:!0,alt:!0}),ne=s(e),R=o(e,"P",{"data-svelte-h":!0}),l(R)!=="svelte-6im12q"&&(R.innerHTML=ze),re=s(e),j=o(e,"P",{"data-svelte-h":!0}),l(j)!=="svelte-1fflllh"&&(j.innerHTML=De),se=s(e),ue(q.$$.fragment,e),ae=s(e),D=o(e,"P",{}),Ee(D).forEach(i),this.h()},h(){h(u,"name","hf:doc:metadata"),h(u,"content",Ne),fe(T.src,_e="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/curiosity2.png")||h(T,"src",_e),h(T,"alt","Curiosity"),fe($.src,ke="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/curiosity3.png")||h($,"src",ke),h($,"alt","Curiosity"),fe(k.src,qe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/curiosity4.png")||h(k,"src",qe),h(k,"alt","Curiosity")},m(e,t){We(document.head,u),n(e,E,t),n(e,z,t),n(e,I,t),he(m,e,t),n(e,S,t),n(e,c,t),n(e,G,t),n(e,p,t),n(e,A,t),he(f,e,t),n(e,O,t),n(e,d,t),n(e,U,t),n(e,g,t),n(e,W,t),n(e,w,t),n(e,F,t),n(e,v,t),n(e,B,t),n(e,y,t),n(e,N,t),n(e,T,t),n(e,V,t),n(e,x,t),n(e,J,t),he(C,e,t),n(e,K,t),n(e,b,t),n(e,Q,t),n(e,_,t),n(e,X,t),n(e,L,t),n(e,Y,t),n(e,M,t),n(e,Z,t),n(e,$,t),n(e,ee,t),n(e,H,t),n(e,te,t),n(e,P,t),n(e,ie,t),n(e,k,t),n(e,ne,t),n(e,R,t),n(e,re,t),n(e,j,t),n(e,se,t),he(q,e,t),n(e,ae,t),n(e,D,t),oe=!0},p:Se,i(e){oe||(me(m.$$.fragment,e),me(f.$$.fragment,e),me(C.$$.fragment,e),me(q.$$.fragment,e),oe=!0)},o(e){ce(m.$$.fragment,e),ce(f.$$.fragment,e),ce(C.$$.fragment,e),ce(q.$$.fragment,e),oe=!1},d(e){e&&(i(E),i(z),i(I),i(S),i(c),i(G),i(p),i(A),i(O),i(d),i(U),i(g),i(W),i(w),i(F),i(v),i(B),i(y),i(N),i(T),i(V),i(x),i(J),i(K),i(b),i(Q),i(_),i(X),i(L),i(Y),i(M),i(Z),i($),i(ee),i(H),i(te),i(P),i(ie),i(k),i(ne),i(R),i(re),i(j),i(se),i(ae),i(D)),i(u),pe(m,e),pe(f,e),pe(C,e),pe(q,e)}}}const Ne='{"title":"(Optional) What is Curiosity in Deep Reinforcement Learning?","local":"optional-what-is-curiosity-in-deep-reinforcement-learning","sections":[{"title":"Two Major Problems in Modern RL","local":"two-major-problems-in-modern-rl","sections":[],"depth":2},{"title":"So what is Curiosity?","local":"so-what-is-curiosity","sections":[],"depth":2}],"depth":1}';function Ve(ge){return Ge(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Xe extends Ae{constructor(u){super(),Oe(this,u,Ve,Be,Ie,{})}}export{Xe as component};
